Bug 1271193 - Review Request: osgi-compendium - Interfaces and Classes for use in compiling OSGi bundles
Review Request: osgi-compendium - Interfaces and Classes for use in compiling...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: gil cattaneo
Fedora Extras Quality Assurance
: Reopened
Depends On: 1381892
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-13 07:05 EDT by Michael Simacek
Modified: 2016-10-10 13:42 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-10-10 13:42:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
puntogil: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Michael Simacek 2015-10-13 07:05:17 EDT
Spec URL: http://msimacek.fedorapeople.org/review/osgi-compendium/osgi-compendium.spec
SRPM URL: http://msimacek.fedorapeople.org/review/osgi-compendium/osgi-compendium-6.0.0-1.fc21.src.rpm
Description: OSGi Compendium, Interfaces and Classes for use in compiling bundles.
Fedora Account System Username: msimacek
Comment 1 Mikolaj Izdebski 2015-10-13 07:36:30 EDT
How does this differ from felix-osgi-compendium?
Comment 2 Michael Simacek 2015-10-13 08:55:04 EDT
felix-osgi-compendium is aliased and patched version of OSGi Compendium 4 (this one is 6). Felix doesn't seem to provide any newer version.
Comment 3 gil cattaneo 2015-10-13 19:52:04 EDT
It seems that it is non-free
look for "does not modify" in the http://www.osgi.org/Main/OSGiDistributionAndFeedbackLicense
Comment 4 Mikolaj Izdebski 2015-10-14 04:26:36 EDT
I share doubts wit Gil. I remember that code from OSGi Alliance used to be non-free and that's why we don't ship any code from them in Fedora. The tarball used in SRPM under review indicates that it may be free software, but it's questionable whether it's genuine and what are the actual licensing terms.

Michael, is it possible to obtain the same source code directly from upstream, bypassing Maven Central? Upstream download page may reveal more details helpful in the review and will help making sure that the code is genuine.
Comment 5 Mat Booth 2015-10-14 05:12:29 EDT
From that link: "The OSGi Alliance hereby grants you a limited copyright license to copy and display this document (the “Distribution”)"

You are not shipping the specification document --- you are shipping an implementation of part of that spec. (An implementation may have a different license to the specification.)
Comment 6 Michael Simacek 2015-10-14 05:53:37 EDT
(In reply to Mikolaj Izdebski from comment #4)
> I share doubts wit Gil. I remember that code from OSGi Alliance used to be
> non-free and that's why we don't ship any code from them in Fedora. The
> tarball used in SRPM under review indicates that it may be free software,
> but it's questionable whether it's genuine and what are the actual licensing
> terms.
> 
> Michael, is it possible to obtain the same source code directly from
> upstream, bypassing Maven Central? Upstream download page may reveal more
> details helpful in the review and will help making sure that the code is
> genuine.

It can be obtained at [0]. It's not the same JAR as it also contains binary classes, but it contains the same source (in OSGI-OPT) and license file. But the catch is that in order to get to download page [1], I had to agree to non-free license at [2]. The subsequent page contains links to both the specification documents and code. The JAR contains no further references to that bad license and only includes ASL and mentions ASL in about.html and file headers.
Based on that, I believe the bad license covers only the specification documents, not the code.

Note that the same interfaces/classes (well, different versions/subsets thereof, otherwise I wouldn't be packaging this) also have to be included in every OSGi implementation, such as felix or equinox, which are considered free and included in Fedora.

[0] https://osgi.org/download/r6/osgi.cmpn-6.0.0.jar
[1] http://www.osgi.org/Download/Release6 (you don't need to fill the form, just submit it as it is)
[2] http://www.osgi.org/Main/OSGiSpecificationLicense
Comment 7 gil cattaneo 2015-10-14 06:18:02 EDT
Seem using 
http://repo1.maven.org/maven2/org/osgi/osgi.cmpn/6.0.0/osgi.cmpn-6.0.0-sources.jar
mssing some xsd files
osgi.cmpn-6.0.0/xmlns/app/v1.0.0/app.xsd
osgi.cmpn-6.0.0/xmlns/app/v1.1.0/app.xsd
osgi.cmpn-6.0.0/xmlns/blueprint/v1.0.0/blueprint.xsd
osgi.cmpn-6.0.0/xmlns/metatype/v1.0.0/metatype.xsd
osgi.cmpn-6.0.0/xmlns/metatype/v1.1.0/metatype.xsd
osgi.cmpn-6.0.0/xmlns/metatype/v1.2.0/metatype.xsd
osgi.cmpn-6.0.0/xmlns/metatype/v1.3.0/metatype.xsd
osgi.cmpn-6.0.0/xmlns/repository/v1.0.0/repository.xsd
osgi.cmpn-6.0.0/xmlns/rest/v1.0.0/rest.xsd
osgi.cmpn-6.0.0/xmlns/rsa/v1.0.0/rsa.xsd
osgi.cmpn-6.0.0/xmlns/scr/v1.0.0/scr.xsd
osgi.cmpn-6.0.0/xmlns/scr/v1.1.0/scr.xsd
osgi.cmpn-6.0.0/xmlns/scr/v1.2.0/scr.xsd
osgi.cmpn-6.0.0/xmlns/scr/v1.3.0/scr.xsd
available in
http://repo1.maven.org/maven2/org/osgi/osgi.cmpn/6.0.0/osgi.cmpn-6.0.0.jar
Comment 8 Mikolaj Izdebski 2015-10-14 09:10:40 EDT
Some notes:

1) OSGi API can be consider part of specification, which is non-free. Downloading APIs from upstream page requires accepting non-free license. Upstream website does not have a separate license page for code accompanying the specification.

2) In some jurisdictions (incl. USA), API is not copyrightable material (i.e. it is always public domain), but comments can be copyrighted. Pure API (with stripped comments) can be considered as free software, even if there is no explicit free license.

In my opinion packaging these APIs is at least problematic and should be done with extra care. If possible I would avoid using any code from OSGi Aliance, until this is cleared with legal.
Comment 9 Tom "spot" Callaway 2015-10-20 10:34:37 EDT
Before we start trying to thread legal loopholes here, could someone please ask the OSGi to clearly state their intended license terms for this software? If they respond with Apache, we will treat it as such.
Comment 10 Michael Simacek 2016-06-02 10:13:08 EDT
I patched it out of aqute and I'm not interesetd in packaging this anymore.
Comment 11 Michael Simacek 2016-10-05 06:45:50 EDT
Reopening.

Spec URL: https://msimacek.fedorapeople.org/osgi-compendium.spec
SRPM URL: https://msimacek.fedorapeople.org/osgi-compendium-6.0.0-1.fc24.src.rpm


There have been some doubts about the licensing of the artifact, due to the fact that in order to download it from upstream web page, it requires the user to agree to a non-free OSGi specification license.

The following is a legal explanation of why this shouldn't be an obstacle for including it in Fedora, kindly provided by Richard Fontana (via email):

The source files in the JAR, containing Apache License 2.0 notices,
are free software, and should be acceptable for packaging in Fedora
and RHEL.

There is definitely something confusing here: the spec license would
seem to apply to the JAR contents as well as the pdf containing the
specification.

However, the spec license has to be read in light of the fact that the
same group granting the spec license is also the group that has
explicitly placed those source files under the Apache License 2.0.

I read the spec license as applying in some sense to the specification
document but not applying to any source files licensed by the OSGi
Alliance under the Apache License. 

Specifically, the spec license says:

  You are not authorized to create any derivative work of the
  Specification. However, to the extent that an implementation of the
  Specification would necessarily be a derivative work of the
  Specification, OSGi also grants you a perpetual, non-exclusive,
  worldwide, fully paid-up, royalty free, limited license (without the
  right to sublicense) under any applicable copyrights, to create
  and/or distribute an implementation of the Specification that: (i)
  fully implements the Specification including all its required
  interfaces and functionality; (ii) does not modify, subset, superset
  or otherwise extend the OSGi Name Space, or include any public or
  protected packages, classes, Java interfaces, fields or methods
  within the OSGi Name Space other than those required and authorized
  by the Specification. An implementation that does not satisfy
  limitations (i)-(ii) is not considered an implementation of the
  Specification, does not receive the benefits of this license, and
  must not be described as an implementation of the Specification.

The Apache License on the other hand explicitly permits creation of
derivative works even if such derivative works fall outside the
conditions here. I.e., one could take the source files in the JAR and
use it to fork the OSGi standard, or to create a nonconformant
implementation of the OSGi standard.

Essentially, the Apache License 2.0 supersedes the spec license as far
as the source files in the JAR are concerned.
Comment 12 gil cattaneo 2016-10-05 11:53:43 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[?]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
   Waiting for Fedora Legal resolution
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated". 62 files have unknown
     license. Detailed output of licensecheck in /home/gil/1271193-osgi-
     compendium/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[?]: Sources contain only permissible code or content.
   As above
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in osgi-
     compendium-javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: osgi-compendium-6.0.0-1.fc26.noarch.rpm
          osgi-compendium-javadoc-6.0.0-1.fc26.noarch.rpm
          osgi-compendium-6.0.0-1.fc26.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
osgi-compendium-javadoc (rpmlib, GLIBC filtered):
    javapackages-tools

osgi-compendium (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(javax.persistence:persistence-api)
    mvn(javax.servlet:javax.servlet-api)
    mvn(org.osgi:osgi.annotation)
    mvn(org.osgi:osgi.core)



Provides
--------
osgi-compendium-javadoc:
    osgi-compendium-javadoc

osgi-compendium:
    mvn(org.osgi:org.osgi.cmpn)
    mvn(org.osgi:org.osgi.cmpn:pom:)
    mvn(org.osgi:osgi.cmpn)
    mvn(org.osgi:osgi.cmpn:pom:)
    osgi(osgi.cmpn)
    osgi-compendium



Source checksums
----------------
https://osgi.org/download/r6/osgi.cmpn-6.0.0.jar :
  CHECKSUM(SHA256) this package     : dbe06105a0e3e46bc88425b3d7c682a2d8b6bd055341913b6c37e998c00c9176
  CHECKSUM(SHA256) upstream package : dbe06105a0e3e46bc88425b3d7c682a2d8b6bd055341913b6c37e998c00c9176


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1271193 --plugins Java -m fedora-rawhide-i386 -L ~/deps
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Built with local dependencies:
    ~/deps/osgi-core-6.0.0-2.fc26.noarch.rpm
Comment 13 gil cattaneo 2016-10-05 11:54:31 EDT
Blocker:

[?]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
   Waiting for Fedora Legal resolution

[?]: Sources contain only permissible code or content.
   As above

Package is approved, but for the inclusion in Fedora we need A FE-Legal response

Please, add Richard Fontana email as an attachment
Comment 14 Tom "spot" Callaway 2016-10-05 11:57:49 EDT
If Richard feels that these files are Apache without issue, I'm content with that. Lifting FE-Legal.
Comment 15 Gwyn Ciesla 2016-10-05 12:13:10 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/osgi-compendium
Comment 16 Fedora Update System 2016-10-06 16:58:38 EDT
osgi-compendium-6.0.0-1.fc25, osgi-core-6.0.0-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-8cd8b793dd
Comment 17 Fedora Update System 2016-10-10 13:42:41 EDT
osgi-compendium-6.0.0-1.fc25, osgi-core-6.0.0-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.